
public class BouncingPixels extends GPixels
{
	protected int					cColorMod;
	
	public void clear() {
		super.clear();
		cColorMod = 0xFFFFFFFF;
	}
	
	public void setColorMod(int colorMod) {
		cColorMod = colorMod;
	}
	
	/*
	Draws the image but multiplies the source color with cColorMod, to produce
	a darker image, with a shade depending on the value of cColorMod.
	*/
	protected void copyPixelsColor(int[] canvas, int canvasWidth, int sourceStart, int destStart,
			int plotWidth, int plotHeight, int deltaX, int deltaY) {
		
		int							yCounter;
		int							xCounter;
		int							sourceIndex;
		int							destIndex;
		
		int							sourceAlpha;
		int							destAlpha;
		int							red;
		int							green;
		int							blue;
		
		sourceIndex = sourceStart;
		destIndex = destStart;
		
		for (yCounter = 0; yCounter < plotHeight; yCounter++) {
			for (xCounter = 0; xCounter < plotWidth; xCounter++) {
				sourceAlpha = ((cPixelArray[sourceIndex] >> 24) & 0xFF) * cAlphaMod / 255;
				
				if (sourceAlpha > 0) { // semi-transparent
					destAlpha = 0xFF - sourceAlpha;
					
					red = ((cPixelArray[sourceIndex] >> 16) & 0xFF) * sourceAlpha *
						((cColorMod >> 16) & 0xFF) / 255 / 255 +
						((canvas[destIndex] >> 16) & 0xFF) * destAlpha / 255;
					
					green = ((cPixelArray[sourceIndex] >> 8) & 0xFF) * sourceAlpha *
						((cColorMod >> 8) & 0xFF) / 255 / 255 +
						((canvas[destIndex] >> 8) & 0xFF) * destAlpha / 255;
					
					blue = (cPixelArray[sourceIndex] & 0xFF) * sourceAlpha *
						(cColorMod & 0xFF) / 255 / 255 +
						(canvas[destIndex] & 0xFF) * destAlpha / 255;
					
					canvas[destIndex] = 0xFF000000 | (red << 16) | (green << 8) | (blue);
				}
				
				destIndex++;
				sourceIndex += deltaX;
			}
			
			destIndex += canvasWidth - plotWidth;
			sourceIndex -= plotWidth * deltaX;
			sourceIndex += deltaY;
		}
	}
	
	protected void copyPixels(int[] canvas, int canvasWidth, int sourceStart, int destStart,
			int plotWidth, int plotHeight, int deltaX, int deltaY) {
		if (cColorMod != 0xFFFFFFFF)
			copyPixelsColor(canvas, canvasWidth, sourceStart, destStart, plotWidth, plotHeight, deltaX, deltaY);
		else
			super.copyPixels(canvas, canvasWidth, sourceStart, destStart, plotWidth, plotHeight, deltaX, deltaY);
	}
}

