
public class BouncingTile extends GTileForm
{
	public static final int			kAnimatedProperty = 0;
	public static final int			kTwoLayersProperty = 1;
	
	public static boolean			cAnimate;
	public static boolean			cTopLayer;
	
	
	public void draw(int frame, int[] canvas, int canvasWidth, int sourceLeft, int sourceTop,
			int sourceRight, int sourceBottom, int destLeft, int destTop) {
		if (cTopLayer) {
			if (getFlag(kTwoLayersProperty))
				getImage(1).drawTile(canvas, canvasWidth, sourceLeft, sourceTop,
						sourceRight, sourceBottom, destLeft, destTop);
			return;
		}
		
		if (getFlag(kAnimatedProperty)) {
			if (!cAnimate) {
				getImage(0).drawTile(canvas, canvasWidth, sourceLeft, sourceTop,
						sourceRight, sourceBottom, destLeft, destTop);
			} else {
				int						alpha;
				
				getImage(0).drawTile(canvas, canvasWidth, sourceLeft, sourceTop,
						sourceRight, sourceBottom, destLeft, destTop);
				
				if (frame % 30 >= 15)
					alpha = (frame % 15) * 10;
				else
					alpha = 150 - (frame % 15) * 10;
				
				getImage(1).setAlphaMod(alpha);
				getImage(1).drawTile(canvas, canvasWidth, sourceLeft, sourceTop,
						sourceRight, sourceBottom, destLeft, destTop);
				getImage(1).setAlphaMod(255);
			}
		} else {
			super.draw(frame, canvas, canvasWidth, sourceLeft, sourceTop,
					sourceRight, sourceBottom, destLeft, destTop);
		}
	}
}

