
public class SnakeBug extends GSprite
{
	static SnakeIIApplet			cApplet;
	
	int								cDirection;
	boolean							cFlipped;
	boolean							cEaten;
	
	
	public SnakeBug(int formIndex) {
		super(formIndex);
		
		cDirection = (int) (Math.random() * 4);
		cFlipped = Math.random() >= 0.5;
		cEaten = false;
	}
	
	public void preProcess(int frame) {
		// change direction once in a while
		if (frame % 10 == 0 && Math.random() > 0.6)
			cDirection = (int) (Math.random() * 4);
		
		// flip back and forth to animate legs
		cFlipped = (frame % 2 == 0);
		
		// move in whatever direction this is facing
		if (cDirection == 0)
			setSpeed(0, -1024);
		else if (cDirection == 1)
			setSpeed(1024, 0);
		else if (cDirection == 2)
			setSpeed(0, 1024);
		else if (cDirection == 3)
			setSpeed(-1024, 0);
		
		// update image mode
		if (cDirection == 0 && cFlipped)
			setCurrentImageMode(4);
		else if (cDirection == 0)
			setCurrentImageMode(0);
		else if (cDirection == 1 && cFlipped)
			setCurrentImageMode(7);
		else if (cDirection == 1)
			setCurrentImageMode(1);
		else if (cDirection == 2 && cFlipped)
			setCurrentImageMode(6);
		else if (cDirection == 2)
			setCurrentImageMode(2);
		else if (cDirection == 3 && cFlipped)
			setCurrentImageMode(5);
		else if (cDirection == 3)
			setCurrentImageMode(3);
	}
	
	public void postProcess(int frame) {
		if (cEaten) {
			// the snake ate this
			cApplet.cLevel.removeSprite(this);
			if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode) {
				// in flesh mode, every bug will be replaced
				cApplet.spawnBug();
			}
		}
	}
}

