
public class SnakeHead extends GSprite
{
	// property constants
	static int[]					sMode = new int[] {0, 0, 0, 7, 1, 1, 1, 6, 2, 2, 2, 5, 3, 3, 3, 4, 0};
	static int[]					sImage = new int[] {0, 1, 2, 1, 0, 1, 2, 1, 0, 1, 2, 1, 0, 1, 2, 1, 0};
	
	static final int				kImageBase = 0;
	static final int				kBoneImageBase = 3;
	static final int				kStartRemoveFleshPeriod = 13;
	static final int				kMinRemoveFleshPeriod = 9;
	
	static int[]					sOffset = new int[] {
									 0, -13,
									 5, -12,
									 9, -9,
									12, -5,
									13,  0,
									12,  5,
									 9,  9,
									 5,  12,
									 0,  13,
									-5,  12,
									-9,  9,
									-12, 5,
									-13, 0,
									-12,-5,
									-9, -9,
									-5, -12,
									 0, -13};
	
	static SnakeIIApplet			cApplet;
	static int						sLives;
	static int						sTotalBugs;
	static int						sControlCountdown;
	
	
	int								cNextX;
	int								cNextY;
	
	SnakeBody						cTail;
	SnakeBody						cSecondTail;
	SnakeBody						cSecondHead;
	
	int								cBugs;
	boolean							cDead;
	int								cAngle;
	int								cPoints;
	int								cFlesh;
	boolean							cWaitForNextLevel;
	
	int								cTurnRequest;
	int								cNextKeyCheck;
	int								cNextRemoveFleshFrame;
	int								cRemoveFleshPeriod;
	
	
	public SnakeHead(int formIndex) {
		super(formIndex);
		
		cNextX = 0;
		cNextY = 0;
		cDead = false;
		cAngle = 4;
		cPoints = 0;
		sControlCountdown = 12;
		cWaitForNextLevel = false;
		cFlesh = 255;
		cRemoveFleshPeriod = kStartRemoveFleshPeriod;
		cNextRemoveFleshFrame = cApplet.getFrame() + 60;
	}
	
	public void draw(int[] canvas, int canvasWidth, int scrollX, int scrollY) {
		int							flesh;
		
		flesh = cFlesh;
		
		// avoid slight skull bone transparency
		if (flesh > 0) {
			flesh += 70;
			if (flesh > 255)
				flesh = 255;
		}
		
		if (flesh == 255)
			// flesh
			super.draw(canvas, canvasWidth, scrollX, scrollY);
		else if (flesh == 0) {
			// bone
			cCurrentImage += kBoneImageBase;
			super.draw(canvas, canvasWidth, scrollX, scrollY);
			cCurrentImage -= kBoneImageBase;
		} else {
			// part flesh, part bone
			GPixels					image;
			
			// check if sprite is visible
			if ((cLocationX >> 10) + getCurrentWidth() < scrollX ||
					(cLocationY >> 10) + getCurrentHeight() < scrollY ||
					(cLocationX >> 10) >= scrollX + canvasWidth ||
					(cLocationY >> 10) >= scrollY + canvas.length / canvasWidth)
				return;
			
			// draw flesh
			image = cForm.getImage(cCurrentImage);
			
			if (image != null) {
				image.setAlphaMod(flesh);
				
				image.drawWrapped(canvas, canvasWidth, getLeft() >> 10, getTop() >> 10,
					cCurrentImageMode, scrollX, scrollY);
				image.setAlphaMod(255);
			}
			
			// draw bone
			image = cForm.getImage(cCurrentImage + kBoneImageBase);
			
			if (image != null) {
				image.setAlphaMod(255 - flesh);
				
				image.drawWrapped(canvas, canvasWidth, getLeft() >> 10, getTop() >> 10,
					cCurrentImageMode, scrollX, scrollY);
				image.setAlphaMod(255);
			}
		}
	}
	
	// normal mode only
	public int bugsLeft() {
		return cBugs - cPoints;
	}
	
	// flesh mode only
	public void killSnake() {
		if (!cDead) {
			// starved to death
			cDead = true;
			
			updateImage();
			
			cApplet.endLevel(10);
		}
	}
	
	// flesh mode only
	public void removeFlesh() {
		cFlesh -= 35;
		if (cFlesh < 0)
			cFlesh = 0;
		
		if (cFlesh < 120)
			killSnake();
	}
	
	// flesh mode only
	public boolean addFlesh() {
		if (cFlesh == 255)
			return true;
		
		cFlesh += 35;
		if (cFlesh > 255)
			cFlesh = 255;
		
		return cFlesh > 75;
	}
	
	public void updateImage() {
		setCurrentImage(sImage[cAngle] + kImageBase);
		
		setCurrentImageMode(sMode[cAngle]);
	}
	
	public void preProcess(int frame) {
		if (cNextKeyCheck == 0) {
			if (cApplet.isKeyActive(cApplet.kPlayerLeft))
				cTurnRequest = -1;
			else if (cApplet.isKeyActive(cApplet.kPlayerRight))
				cTurnRequest = 1;
			
			if (cTurnRequest != 0)
				cNextKeyCheck = 2;
		} else
			cNextKeyCheck--;
		
		if (frame % 3 != 0 || cDead || cWaitForNextLevel) {
			setSpeedX(0);
			setSpeedY(0);
			return;
		}
		
		// snake moving right: 1 = tail; 9 = head; 2 = second head/tail
		// 1 2 3 4...7 8 9
		//   1 3 4...7 8 2 9
		
		// move tail to second tail
		cTail.cAngle = cSecondTail.cAngle;
		cTail.cWiggle = cSecondTail.cWiggle;
		cTail.setLocation(cSecondTail.getLocationX(), cSecondTail.getLocationY());
		cTail.setLocation(cSecondTail.getLocationX(), cSecondTail.getLocationY());
		cTail.updateImage();
		cTail.cLeader = cSecondTail.cLeader;
		
		// move second tail to sprite
		cSecondTail.cAngle = cAngle;
		cSecondTail.setLocation(getLocationX(), getLocationY());
		cSecondTail.updateImage();
		
		// update second head.leader
		cSecondHead.cLeader = cSecondTail;
		
		// update second tail.leader
		cSecondTail.cLeader = this;
		
		// update references
		cSecondHead = (SnakeBody) cSecondTail;
		cSecondTail = (SnakeBody) cTail.cLeader;
		
		if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode) {
			// move flesh border
			cSecondHead.cFlesh = cFlesh;
			addFlesh();
			cTail.removeFlesh();
		}
		
		// move the head
		if (sControlCountdown > 0)
			sControlCountdown--;
		else {
			if (cTurnRequest < 0) {
				cAngle--;
				if (cAngle < 0)
					cAngle += 16;
			} else if (cTurnRequest > 0) {
				cAngle++;
				if (cAngle >= 16)
					cAngle -= 16;
			}
		}
		
		cTurnRequest = 0;
		
		updateImage();
		
		if (cNextX == 0 && cNextY == 0) {
			// first frame
			setSpeedX(1024 * sOffset[cAngle * 2]);
			setSpeedY(1024 * sOffset[cAngle * 2 + 1]);
		} else {
			setSpeedX(1024 * ((int) ((cNextX + sOffset[cAngle * 2]) / 2)));
			setSpeedY(1024 * ((int) ((cNextY + sOffset[cAngle * 2 + 1]) / 2)));
		}
		
		cNextX = sOffset[cAngle * 2];
		cNextY = sOffset[cAngle * 2 + 1];
	}
	
	public void postProcess(int frame) {
		if (getTouchingSolid() && !cDead && !cWaitForNextLevel) {
			cDead = true;
			updateImage();
			
			setDetectCollision(false);
			setCollisionEffect(-1);
			if (cApplet.getGameMode() == SnakeIIApplet.kNormalMode) {
				sLives--;
				if (sLives > 0)
					cApplet.restartLevel(20);
				else
					cApplet.endLevel(20);
			} else if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode)
				cApplet.endLevel(20);
		} else if (cDead) {
			removeFlesh();
			cTail.decaySegment();
		}
		
		if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode && frame > cNextRemoveFleshFrame) {
			cTail.removeFlesh();
			
			cNextRemoveFleshFrame += cRemoveFleshPeriod;
		}
		
		if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode && frame % 150 == 0) {
			cRemoveFleshPeriod--;
			
			if (cRemoveFleshPeriod < kMinRemoveFleshPeriod)
				cRemoveFleshPeriod = kMinRemoveFleshPeriod;
		}
		
		// scrolling
		cApplet.cTargetCenterX = getLocationX() >> 10;
		cApplet.cTargetCenterY = getLocationY() >> 10;
	}
	
	public void collideWith(GSprite other, int frame) {
		if (other.getCollisionEffect() == 1) { // bug
			// mark bug as eaten
			((SnakeBug) other).cEaten = true;
			
			// award points
			cPoints++;
			if (cPoints > sTotalBugs)
				sTotalBugs = cPoints;
			
			if (cApplet.getGameMode() == SnakeIIApplet.kNormalMode) {
				if (cPoints >= cBugs) {
					cApplet.advanceLevel(5);
					cWaitForNextLevel = true;
					cTail.waitForNextLevel();
				}
			} else if (cApplet.getGameMode() == SnakeIIApplet.kFleshMode) {
				cTail.addFlesh();
				cTail.addFlesh();
				cTail.addFlesh();
			}
		}
	}
}


