
public class WrappingPlayer extends GSprite
{
	static final int				kSpeed = 6144;
	
	// allows communicating with the WrappingApplet, telling
	// it where to scroll
	static WrappingApplet			cApplet;
	
	// keeping track of how much the ball has been rolling
	int								cAnimationFrame;
	
	
	public WrappingPlayer(int formIndex) {
		super(formIndex);
		cAnimationFrame = 0;
	}
	
	public void preProcess(int frame) {
		// handle movement
		if (cApplet.isKeyActive(cApplet.kLeft))
			setSpeedX(-kSpeed);
		else if (cApplet.isKeyActive(cApplet.kRight))
			setSpeedX(kSpeed);
		else
			setSpeedX(0);
		
		if (cApplet.isKeyActive(cApplet.kUp))
			setSpeedY(-kSpeed);
		else if (cApplet.isKeyActive(cApplet.kDown))
			setSpeedY(kSpeed);
		else
			setSpeedY(0);
		
		if (frame % 2 == 0) {
			// update animation
			cAnimationFrame++;
			
			if (cAnimationFrame % 4 == 0)
				cCurrentImage = 0;
			else if (cAnimationFrame % 4 == 2)
				cCurrentImage = 2;
			else
				cCurrentImage = 1;
			
			if (cAnimationFrame % 4 == 3)
				cCurrentImageMode = 4;
			else
				cCurrentImageMode = 0;
			
			if (cAnimationFrame % 8 >= 4)
				cCurrentImageMode = GPixels.getRotateMode(cCurrentImageMode, 1);
		}
	}
	
	public void postProcess(int frame) {
		// tell the applet where to scroll
		cApplet.cTargetCenterX = cLocationX >> 10;
		cApplet.cTargetCenterY = cLocationY >> 10;
	}
}


